#ifndef _COURSECOLLECTION_H
#define _COURSECOLLECTION_H

#include <string>
#include <fstream>

#include "Course.h"

using namespace std;

class CourseCollection // version 1
{
friend void StudentInCourseCollection::add1StudentInCourse(
                              const StudentInCourse& aStdnInCrs );
friend void StudentInCourseCollection::delete1StudentInCourse(
                                        int aIdNum, string code );
public:
   CourseCollection();
   ~CourseCollection()  {  delete[] ccArr;  };
// getters
   size_t getNOfCourses() const {  return ccNOfCourses;  }
   const Course* getArr() const {  return ccArr;  }
// setters
// 1 Course
   bool find1Course( const string& code ) const
   {  return ( findNdx(code) >= 0 );  };
   void delete1Course( string code );
   void add1Course( const Course& aCourse );
   const Course& get1Course( string code ) const;
//   const Course& operator[]( string code ) const;
// other
   void save( ofstream& bout ) const;
   void load( ifstream& bin );
   void swap( CourseCollection& rhs );
   void display( ostream& tout ) const;
private:
   enum { ccIncr = 30 };
   Course*                    ccArr;
   size_t                     ccNOfCourses;
   size_t                     ccReserved;

   CourseCollection( const CourseCollection& rhs ) { };
   CourseCollection& operator=( const CourseCollection& rhs ) { };
   void erase1Course( int ndx );
   void insert1Course( const Course& aCourse );
   void add1Student( string code );
   void delete1Student( string code );
   int findNdx( const string& code ) const;
}; // CourseCollection

struct CourseCollectionXptn // version 1
{
   enum { allocFailed, notFound, entity, //cannotDel, 
          prereqRef,
          noEnroll, enrollRef, fileNotOpen, cannotWrite, cannotRead };
   char methodName[100];
   int  errorCode;
   char errStrVal[100];
   int  errIntVal;
   CourseCollectionXptn( const char* mn, int ec,
                         const char* sv="", int iv=0 )
      :  errorCode( ec ),  errIntVal( iv )
   {  strncpy( methodName, mn, 99 );  methodName[99] = '\0';
      strncpy( errStrVal, sv, 99 );  errStrVal[99] = '\0';  };
}; // CourseCollectionXptn

#endif // _COURSECOLLECTION_H
